<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Preferences
  {

   function __construct() { }

   public static function getGeneralPrefFieldsArray()
    {
     return array('total_visitors','total_signalations',
                  'skin','site_address','webmaster_email','service_email','logo','logo_width','logo_height','foot_content','home_news_max',
                  'banners_enabled','logging_enabled',
                  'user_groupID','user_enabled','user_special','user_flag1','user_flag2','user_flag3','user_flag4','user_flag5','user_flag6','user_flag7','user_flag8');
    }

   public static function getAspectPrefFieldsArray()
    {
     return array('show_total_newsletter','show_total_signalations','show_total_search_engine','show_online_users_visitors','show_home_news','show_full_news','enable_news_comments','anonymous_news_comments','show_home_channels','hide_left_panels_action_home','hide_right_panels_action_home','anonymous_write_news','anonymous_enabled_news','anonymous_add_directories','anonymous_enabled_directories','anonymous_vote_directories','anonymous_vote_media_albums');
    }

   public static function getContentPrefFieldsArray()
    {//TODO
     return array('browser_bar_title','title','special_user_label','staff_name','home','foot',
                  'signalation_email_subject','signalation_email_text','user_registration_email_subject','user_registration_email_text',
                  'languageID');
    }

   public static function getEcommercePrefFieldsArray()
    {
     return array('ecommerce_type','ecommerce_credit_card_url','ecommerce_currency','ecommerce_shipping_cost','ecommerce_cart_expire','ecommerce_show_catalogue_price','ecommerce_show_extra','ecommerce_variable_price','ecommerce_variable_id');
    }

   public static function getEcommerceFieldPreferencesFieldsArray()
    {
	 $_ARRAY = array('fieldID','type','size','show_in','required','enabled','label','ts');
	 $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = mysql_fetch_object($rs)) array_push($_ARRAY,'label'.$row->languageID);
     return $_ARRAY;
    }

   public static function getEcommerceLabelPreferencesFieldsArray()
    {
     return array('labelID','fieldID','label','enabled','languageID','ts');
    }

   public static function getBannersExchangePrefFieldsArray()
    {
     return array('banners_exchange_enabled','banners_exchange_ratio','banners_exchange_extra_content','banners_exchange_auto_enabled','banners_exchange_starting_credits');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_CHANGE_LANGUAGE_CONTENT_PREFERENCES:
        {
         $languageID = wm3Language::writeCookiePreferencesLanguageID($_POST['languageID']);
         $w3->setPreferencesLanguage($languageID);
         return wm3Preferences::editContentPreferences($w3);
         break;
        }
       case WM3_cACTION_SET_TOTAL_VISITORS:
        {
         //$error = wm3Preferences::checkTotalVisitorsPreferencesError($w3);
		 $error = 0; // TODO eventuale controllo errori
         if(!$error)
          {
           wm3Preferences::updateTotalVisitorsPreferences($w3);
           // $msg= message udated... //TODO
           return wm3Preferences::editGeneralPreferences($w3);
          }
         else return wm3Preferences::editGeneralPreferences($w3,$error);
         break;
        }
       case WM3_cACTION_SET_TOTAL_SIGNALATIONS:
        {
         //$error = wm3Preferences::checkTotalSignalationsPreferencesError($w3);
		 $error = 0; // TODO eventuale controllo errori
         if(!$error)
          {
           wm3Preferences::updateTotalSignalationsPreferences($w3);
           // $msg= message udated... //TODO
           return wm3Preferences::editGeneralPreferences($w3);
          }
         else return wm3Preferences::editGeneralPreferences($w3,$error);
         break;
        }
       case WM3_cACTION_UPDATE_GENERAL_PREFERENCES:
        {
         $error = wm3Preferences::checkGeneralPreferencesError($w3);
         if(!$error)
          {
           wm3Preferences::updateGeneralPreferences($w3);
           // $msg= message udated... //TODO
		   header("Location: ".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PREFERENCES);
           return wm3Preferences::editGeneralPreferences($w3);
          }
         else return wm3Preferences::editGeneralPreferences($w3,$error);
         break;
        }
       case WM3_cACTION_UPDATE_ASPECT_PREFERENCES:
        {
         $error = wm3Preferences::checkAspectPreferencesError($w3);
         if(!$error)
          {
           wm3Preferences::updateAspectPreferences($w3);
           // $msg= message udated... //TODO
           return wm3Preferences::editAspectPreferences($w3);
          }
         else return wm3Preferences::editAspectPreferences($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_ASPECT_PREFERENCES:
        {
         return wm3Preferences::editAspectPreferences($w3);
         break;
        }        
       case WM3_cACTION_UPDATE_CONTENT_PREFERENCES:
        {
         $error = wm3Preferences::checkContentPreferencesError($w3);
         if(!$error)
          {
           wm3Preferences::updateContentPreferences($w3);
           // $msg= message udated... //TODO
           return wm3Preferences::editContentPreferences($w3);
          }
         else return wm3Preferences::editContentPreferences($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_CONTENT_PREFERENCES:
        {
         return wm3Preferences::editContentPreferences($w3);
         break;
        }
       case WM3_cACTION_UPDATE_ECOMMERCE_PREFERENCES:
        {
         $error = wm3Preferences::checkEcommercePreferencesError($w3);
         if(!$error)
          {
           wm3Preferences::updateEcommercePreferences($w3);
           // $msg= message udated... //TODO
           return wm3Preferences::editEcommercePreferences($w3);
          }
         else return wm3Preferences::editEcommercePreferences($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_PREFERENCES:
        {
         return wm3Preferences::editEcommercePreferences($w3);
         break;
        }

	   case WM3_cACTION_DISABLE_ECOMMERCE_FIELD_PREFERENCES:
        {
         wm3Preferences::disableEcommerceFieldPreferences($w3->getVariable('fieldID','get'));
         return wm3Preferences::getEcommerceFieldPreferencesList($w3,$w3->getVariable('fieldID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_FIELD_PREFERENCES:
        {
         wm3Preferences::enableEcommerceFieldPreferences($w3->getVariable('fieldID','get'));
         return wm3Preferences::getEcommerceFieldPreferencesList($w3,$w3->getVariable('fieldID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_FIELD_PREFERENCES:
        {
         wm3Preferences::deleteEcommerceFieldPreferences($w3->getVariable('fieldID','get'));
         return wm3Preferences::getEcommerceFieldPreferencesList($w3);
         break;
        }
       case WM3_cACTION_ADD_ECOMMERCE_FIELD_PREFERENCES:
        {
         return wm3Preferences::addEcommerceFieldPreferences($w3);
         break;
        }
       case WM3_cACTION_SAVE_ECOMMERCE_FIELD_PREFERENCES:
        {
         $error = wm3Preferences::checkEcommerceFieldPreferencesError($w3);
         if(!$error)
          {
           $lastID = wm3Preferences::saveEcommerceFieldPreferences($w3);
           // $msg= message saved... //TODO
           return wm3Preferences::getEcommerceFieldPreferencesList($w3,$lastID);
          }
         else return wm3Preferences::addEcommerceFieldPreferences($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_FIELD_PREFERENCES:
        {
         return wm3Preferences::editEcommerceFieldPreferences($w3);
         break;
        }
       case WM3_cACTION_UPDATE_ECOMMERCE_FIELD_PREFERENCES:
        {
         $error = wm3Preferences::checkEcommerceFieldPreferencesError($w3);
         if(!$error)
          {
           $lastID = wm3Preferences::updateEcommerceFieldPreferences($w3);
           // $msg= message udated... //TODO
           return wm3Preferences::getEcommerceFieldPreferencesList($w3,$lastID);
          }
         else return wm3Preferences::editEcommerceFieldPreferences($w3,$error);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_FIELD_PREFERENCES:
        {
         return wm3Preferences::getEcommerceFieldPreferencesList($w3);
         break;
        }

       case WM3_cACTION_UPDATE_BANNER_EXCHANGE_PREFERENCES:
        {
         $error = wm3Preferences::checkBannersExchangePreferencesError($w3);
         if(!$error)
          {
           wm3Preferences::updateBannersExchangePreferences($w3);
           // $msg= message udated... //TODO
           return wm3Preferences::editBannersExchangePreferences($w3);
          }
         else return wm3Preferences::editBannersExchangePreferences($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_BANNER_EXCHANGE_PREFERENCES:
        {
         return wm3Preferences::editBannersExchangePreferences($w3);
         break;
        }
       default:
        {
         return wm3Preferences::editGeneralPreferences($w3);
        }
      } 
    }

   public static function checkGeneralPreferencesError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray());
     return 0;
    }

   public static function editGeneralPreferences($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = mysql_fetch_object($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getGeneralPrefFieldsArray(),$row);
       // Default value for fields not in $row object
       $_FIELD['total_visitors']     = wm3Preferences::loadTotalVisitors();
       $_FIELD['total_signalations'] = wm3Preferences::loadTotalSignalations();
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Preferences::getGeneralPrefFieldsArray());
     switch($error)
      {
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1393);
       	}
      }
     $preview_image     = $_FIELD['skin']."/preview.png"; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_SKINS); // Set due preview image
     $next_action       = WM3_cACTION_UPDATE_GENERAL_PREFERENCES;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_preferences_general_form.inc");
     return $content;
    }

   public static function updateGeneralPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET skin            = '".$_FIELD['skin']."',
                           site_address    = '".$_FIELD['site_address']."',
                           webmaster_email = '".$_FIELD['webmaster_email']."',
                           service_email   = '".$_FIELD['service_email']."',
                           logo            = '".$_FIELD['logo']."',
                           logo_height     = '".$_FIELD['logo_height']."',
                           logo_width      = '".$_FIELD['logo_width']."',
                           foot_content    = '".$_FIELD['foot_content']."',
                           home_news_max   = '".$_FIELD['home_news_max']."',
                           banners_enabled = '".$_FIELD['banners_enabled']."',
                           logging_enabled = '".$_FIELD['logging_enabled']."',
                           user_groupID    = '".$_FIELD['user_groupID']."',
                           user_enabled    = '".$_FIELD['user_enabled']."',
                           user_special    = '".$_FIELD['user_special']."',
                           user_flag1      = '".$_FIELD['user_flag1']."',
                           user_flag2      = '".$_FIELD['user_flag2']."',
                           user_flag3      = '".$_FIELD['user_flag3']."',
                           user_flag4      = '".$_FIELD['user_flag4']."',
                           user_flag5      = '".$_FIELD['user_flag5']."',
                           user_flag6      = '".$_FIELD['user_flag6']."',
                           user_flag7      = '".$_FIELD['user_flag7']."',
                           user_flag8      = '".$_FIELD['user_flag8']."'");
    }

   public static function checkAspectPreferencesError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getAspectPrefFieldsArray());
     return 0;
    }

   public static function editAspectPreferences($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = mysql_fetch_object($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getAspectPrefFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getAspectPrefFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Preferences::getAspectPrefFieldsArray());
     switch($error)
      {
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(722);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_ASPECT_PREFERENCES;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_preferences_aspect_form.inc");
     return $content;
    }

   public static function updateAspectPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getAspectPrefFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET show_total_newsletter         = '".$_FIELD['show_total_newsletter']."',
                           show_total_signalations       = '".$_FIELD['show_total_signalations']."',
                           show_total_search_engine      = '".$_FIELD['show_total_search_engine']."',
                           show_online_users_visitors    = '".$_FIELD['show_online_users_visitors']."',
                           show_home_news                = '".$_FIELD['show_home_news']."',
                           show_full_news                = '".$_FIELD['show_full_news']."',
                           enable_news_comments          = '".$_FIELD['enable_news_comments']."',
                           anonymous_news_comments       = '".$_FIELD['anonymous_news_comments']."',
                           show_home_channels            = '".$_FIELD['show_home_channels']."',
                           hide_left_panels_action_home  = '".$_FIELD['hide_left_panels_action_home']."',
						   hide_right_panels_action_home = '".$_FIELD['hide_right_panels_action_home']."',
                           anonymous_write_news          = '".$_FIELD['anonymous_write_news']."',
                           anonymous_enabled_news        = '".$_FIELD['anonymous_enabled_news']."',
                           anonymous_add_directories     = '".$_FIELD['anonymous_add_directories']."',
                           anonymous_enabled_directories = '".$_FIELD['anonymous_enabled_directories']."',
                           anonymous_vote_directories    = '".$_FIELD['anonymous_vote_directories']."',
                           anonymous_vote_media_albums   = '".$_FIELD['anonymous_vote_media_albums']."'");
    }

   public static function checkContentPreferencesError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getContentPrefFieldsArray());
     return 0;
    }

   public static function editContentPreferences($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                               WHERE languageID='".$w3->getPreferencesLanguage()."'");
       $row = mysql_fetch_object($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getContentPrefFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getContentPrefFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Preferences::getContentPrefFieldsArray());
     switch($error)
      {
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(723);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_CONTENT_PREFERENCES;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_preferences_content_form.inc");
     return $content;
    }

   public static function updateContentPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getContentPrefFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                       SET   browser_bar_title               = '".$_FIELD['browser_bar_title']."',
                             title                           = '".$_FIELD['title']."',
                             special_user_label              = '".$_FIELD['special_user_label']."',
                             staff_name                      = '".$_FIELD['staff_name']."',
                             home                            = '".$_FIELD['home']."',
                             foot                            = '".$_FIELD['foot']."',
                             signalation_email_subject       = '".$_FIELD['signalation_email_subject']."',
                             signalation_email_text          = '".$_FIELD['signalation_email_text']."',
                             user_registration_email_subject = '".$_FIELD['user_registration_email_subject']."',
                             user_registration_email_text    = '".$_FIELD['user_registration_email_text']."'
					   WHERE languageID='".$_FIELD['languageID']."'");
    }

   public static function checkEcommercePreferencesError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommercePrefFieldsArray());
	 if($_FIELD['ecommerce_shipping_cost'] < 0) return 1;
	 if($_FIELD['ecommerce_cart_expire']   < 1) return 2;
     return 0;
    }

   public static function editEcommercePreferences($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = mysql_fetch_object($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getEcommercePrefFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommercePrefFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Preferences::getEcommercePrefFieldsArray());
     switch($error)
      {
       case 1: // Invalid shipping cost 
        {
         $_STYLE['ecommerce_shipping_cost'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']               = WM3_cSKIN_ERROR;
         $form_title = "Invalid shipping cost";//$w3->getWord(8);
         break;
        }
       case 2: // Invalid cart expire days 
        {
         $_STYLE['ecommerce_cart_expire'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']             = WM3_cSKIN_ERROR;
         $form_title = "Invalid expire days";//$w3->getWord(8);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(725);
       	}
      }
     $ecommerce_preferences_submenu = wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3);
     $next_action                   = WM3_cACTION_UPDATE_ECOMMERCE_PREFERENCES;
     $next_action_label             = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_preferences_ecommerce_form.inc");
     return $content;
    }

   public static function updateEcommercePreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommercePrefFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET ecommerce_type                 = '".$_FIELD['ecommerce_type']."',
					       ecommerce_credit_card_url      = '".$_FIELD['ecommerce_credit_card_url']."',
						   ecommerce_currency             = '".$_FIELD['ecommerce_currency']."',
					       ecommerce_shipping_cost        = '".$_FIELD['ecommerce_shipping_cost']."',
						   ecommerce_cart_expire          = '".$_FIELD['ecommerce_cart_expire']."',
					       ecommerce_show_catalogue_price = '".$_FIELD['ecommerce_show_catalogue_price']."',
                           ecommerce_show_extra           = '".$_FIELD['ecommerce_show_extra']."',
						   ecommerce_variable_price       = '".$_FIELD['ecommerce_variable_price']."',
						   ecommerce_variable_id          = '".$_FIELD['ecommerce_variable_id']."'");
	 $w3->setPreferences(); // Reload the preferences
    }

   public static function getEcommerceFieldPreferencesList($w3,$currentID = 0,$admin = true)
    {
     // Get ecommerce custom fields list

     // Prepare variables to create the list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg','both');
     $width_label = 50;
     $columns = 5; $buttons = 3;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'fieldID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $str = wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3,$w3->getWord(1471));

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_label,50,0),array(1226,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&fieldID=$row->fieldID";
	   if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_INTEGER) $type = $w3->getWord(1475);
	   if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_DECIMAL) $type = $w3->getWord(1476);
	   if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_STRING)  $type = $w3->getWord(1477);
	   if($row->required) $required = $w3->getWord(1474); else $required = "";
	   $label = wm3Ecommerce::getEcommerceCustomFieldLabel($row->fieldID,$w3->getAdminLanguage());
	   $info = "$type ($row->size) $required";
	   array_push($_CONTENTS,$label); array_push($_WIDTHS,$width_label);
       array_push($_CONTENTS,$info);  array_push($_WIDTHS,30);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_ECOMMERCE_FIELD_PREFERENCES,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_ECOMMERCE_FIELD_PREFERENCES,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_ECOMMERCE_FIELD_PREFERENCES,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_ECOMMERCE_FIELD_PREFERENCES,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->fieldID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkEcommerceFieldPreferencesError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray());
     if($_FIELD['size'] < 1) return 1;
     return 0;
    }

   public static function addEcommerceFieldPreferences($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // Invalid size 
        {
         $_STYLE['size']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid field size";//$w3->getWord(8);
         break;
        }
       default:
        {
         // Default values for the form
		 $_FIELD['required']  = WM3_cDISABLED;
         $_FIELD['enabled']   = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1472);
       	}
      }

	 // Create input for labels
	 $label_textfields = wm3Preferences::makeEcommerceFieldPreferencesInputLabel($w3,$_STYLE['label'],$_FIELD);

     $ecommerce_preferences_submenu = wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3);
     $next_action                   = WM3_cACTION_SAVE_ECOMMERCE_FIELD_PREFERENCES;
     $next_action_label             = $w3->getWord(191);
	 require(WM3_cPATH_INCLUDE."admin_preferences_ecommerce_field_form.inc");
     return $content;
    }

   public static function editEcommerceFieldPreferences($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                               WHERE fieldID = '".$w3->getVariable('fieldID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray(),$row);
       // Default value for fields not in $row object
	   $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
       while($row = mysql_fetch_object($rs))
	    {
	     array_push($_FIELD,'label'.$row->languageID);
	     $_FIELD['label'.$row->languageID] = wm3Ecommerce::getEcommerceCustomFieldLabel($_FIELD['fieldID'],$row->languageID);
	    }
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // Invalid size 
        {
         $_STYLE['size']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid field size";//$w3->getWord(8);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit field"; //$w3->getWord(29);
       	}
      }

	 // Create input for labels
	 $label_textfields = wm3Preferences::makeEcommerceFieldPreferencesInputLabel($w3,$_STYLE['label'],$_FIELD);

     $ecommerce_preferences_submenu = wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3);
     $next_action                   = WM3_cACTION_UPDATE_ECOMMERCE_FIELD_PREFERENCES;
     $next_action_label             = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_preferences_ecommerce_field_form.inc");
     return $content;
    }

   public static function saveEcommerceFieldPreferences($w3)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_languages               WRITE");
     $_ARRAY = array('label');	 
	 $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = mysql_fetch_object($rs)) array_push($_ARRAY,'label'.$row->languageID);

     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['languageID'] = WM3_cLANGUAGE_ALL;
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_ecommerce_custom_fields',$_FIELD,$_ARRAY);
	 $fieldID = wm3Sql::getLastInsertID();

     // Save labels (one label for each language)
	 $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = mysql_fetch_object($rs))
	  wm3Preferences::saveEcommerceLabelPreferences($_FIELD['label'.$row->languageID],$fieldID,$row->languageID,$_FIELD['ts']);

	 wm3Sql::sqlQuery("UNLOCK TABLES");
     return $fieldID;
    }

   public static function saveEcommerceLabelPreferences($label,$fieldID,$languageID,$ts)
    {
	 $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceLabelPreferencesFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['fieldID']    = $fieldID;
	 $_FIELD['label']      = $label;
	 $_FIELD['enabled']    = WM3_cENABLED;
	 $_FIELD['languageID'] = $languageID;
	 $_FIELD['ts']         = $ts;
	 wm3Sql::saveAllTableFields('_ecommerce_custom_labels',$_FIELD,$languageID);
    }

   public static function updateEcommerceFieldPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                       SET   type     = '".$_FIELD['type']."',
					         size     = '".$_FIELD['size']."',
							 show_in  = '".$_FIELD['show_in']."',
							 required = '".$_FIELD['required']."',
                             enabled  = '".$_FIELD['enabled']."'
                       WHERE fieldID  = '".$_FIELD['fieldID']."'");

     // Update labels (one label for each language)
	 $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = mysql_fetch_object($rs))
	  wm3Preferences::updateEcommerceLabelPreferences($w3,$_FIELD['label'.$row->languageID],$_FIELD['fieldID'],$row->languageID);

     return $_FIELD['fieldID'];
    }

   public static function updateEcommerceLabelPreferences($w3,$label,$fieldID,$languageID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
                       SET   label      = '$label'
                       WHERE fieldID    = '$fieldID' AND
					         languageID = '$languageID'");
    }

   public static function disableEcommerceFieldPreferences($fieldID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields SET enabled = '".WM3_cDISABLED."' WHERE fieldID = '$fieldID'");
	}

   public static function enableEcommerceFieldPreferences($fieldID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields SET enabled = '".WM3_cENABLED."' WHERE fieldID = '$fieldID'");
	}
   
   public static function deleteEcommerceFieldPreferences($fieldID)
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WHERE fieldID = '$fieldID'");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels WHERE fieldID = '$fieldID'");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WHERE fieldID = '$fieldID'");
	}

   public static function checkBannersExchangePreferencesError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getBannersExchangePrefFieldsArray());
	 if($_FIELD['banners_exchange_ratio'] < 1) return 1;
     return 0;
    }

   public static function editBannersExchangePreferences($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = mysql_fetch_object($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getBannersExchangePrefFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getBannersExchangePrefFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Preferences::getBannersExchangePrefFieldsArray());
     switch($error)
      {
       case 1: // Invalid ratio
        {
         $_STYLE['banners_exchange_ratio'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']              = WM3_cSKIN_ERROR;
         $form_title = "Invalid ratio";//$w3->getWord(367);
         break;
        }	   
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1320);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_BANNER_EXCHANGE_PREFERENCES;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_preferences_banner_exchange_form.inc");
     return $content;
    }

   public static function updateBannersExchangePreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getBannersExchangePrefFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET banners_exchange_enabled          = '".$_FIELD['banners_exchange_enabled']."',
					       banners_exchange_ratio            = '".$_FIELD['banners_exchange_ratio']."',
					       banners_exchange_extra_content    = '".$_FIELD['banners_exchange_extra_content']."',
						   banners_exchange_auto_enabled     = '".$_FIELD['banners_exchange_auto_enabled']."',
						   banners_exchange_starting_credits = '".$_FIELD['banners_exchange_starting_credits']."'");
    }

   public static function updateTotalVisitorsPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_visitors = '".$_FIELD['total_visitors']."'");
    }

   public static function updateTotalSignalationsPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_signalations = '".$_FIELD['total_signalations']."'");
    }

   public static function incrementTotalVisitorsPreferences()
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_visitors = total_visitors + 1");
    }

   public static function incrementTotalSignalationsPreferences()
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_signalations = total_signalations + 1");
    }

   public static function updateMaxUsersVisitors()
    {
	 $max_visitors = wm3Session::getOnlineVisitors();
	 $max_users = wm3Session::getOnlineUsers();
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
	                      SET max_visitors = $max_visitors
						WHERE max_visitors < $max_visitors");
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
	                      SET max_users = $max_users
						WHERE max_users < $max_users");
	}

   public static function updateLastUserVisitor($w3)
    {
	 if(!$w3->getAuthenticateAdminID()) // Get only normal users or visitors (not administrators)
	  {
	   $ts = time();
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
	                        SET last_user_ip  = '".getenv('REMOTE_ADDR')."',
                                last_user_dns = '".gethostbyaddr(getenv('REMOTE_ADDR'))."',
							    last_userID   = '".$w3->getAuthenticateUserID()."',
							    last_user_ts  = '$ts'");
      }
	}

   public static function loadPreferences()
    {
     // Load preferences from db
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
     $row = mysql_fetch_object($rs);
	 $_PREFERENCES['banners_enabled']                   = $row->banners_enabled;
     $_PREFERENCES['banner1ID']                         = $row->banner1ID;
     $_PREFERENCES['banner2ID']                         = $row->banner2ID;
     $_PREFERENCES['banner3ID']                         = $row->banner3ID;
     $_PREFERENCES['banner4ID']                         = $row->banner4ID;
     $_PREFERENCES['banner5ID']                         = $row->banner5ID;
     $_PREFERENCES['banner6ID']                         = $row->banner6ID;
     $_PREFERENCES['banner7ID']                         = $row->banner7ID;
     $_PREFERENCES['banner8ID']                         = $row->banner8ID;
     $_PREFERENCES['banner9ID']                         = $row->banner9ID;
	 $_PREFERENCES['banners_exchange_enabled']          = $row->banners_exchange_enabled;
	 $_PREFERENCES['banners_exchange_ratio']            = $row->banners_exchange_ratio;
	 $_PREFERENCES['banners_exchange_extra_content']    = $row->banners_exchange_extra_content;
	 $_PREFERENCES['banners_exchange_auto_enabled']     = $row->banners_exchange_auto_enabled;
	 $_PREFERENCES['banners_exchange_starting_credits'] = $row->banners_exchange_starting_credits;
     $_PREFERENCES['logo']         = $row->logo;
     $_PREFERENCES['logo_width']   = $row->logo_width;
     $_PREFERENCES['logo_height']  = $row->logo_height;
     $_PREFERENCES['skin']         = $row->skin; // TODO will be "default" if the .css file do not exist or some error
	 $_PREFERENCES['site_address'] = $row->site_address;
	 $_PREFERENCES['foot_content'] = $row->foot_content;
	 $_PREFERENCES['webmaster_email'] = $row->webmaster_email;
	 $_PREFERENCES['service_email']   = $row->service_email;
	 $_PREFERENCES['home_news_max']                 = $row->home_news_max;
     $_PREFERENCES['show_total_newsletter']         = $row->show_total_newsletter;
     $_PREFERENCES['show_total_signalations']       = $row->show_total_signalations;
     $_PREFERENCES['show_total_search_engine']      = $row->show_total_search_engine;
     $_PREFERENCES['show_online_users_visitors']    = $row->show_online_users_visitors;
     $_PREFERENCES['show_home_news']                = $row->show_home_news;
     $_PREFERENCES['show_full_news']                = $row->show_full_news;
     $_PREFERENCES['enable_news_comments']          = $row->enable_news_comments;
     $_PREFERENCES['anonymous_news_comments']       = $row->anonymous_news_comments;
     $_PREFERENCES['show_home_channels']            = $row->show_home_channels;
     $_PREFERENCES['hide_left_panels_action_home']  = $row->hide_left_panels_action_home;
	 $_PREFERENCES['hide_right_panels_action_home'] = $row->hide_right_panels_action_home;
     $_PREFERENCES['anonymous_write_news']          = $row->anonymous_write_news;
     $_PREFERENCES['anonymous_enabled_news']        = $row->anonymous_enabled_news;
     $_PREFERENCES['anonymous_add_directories']     = $row->anonymous_add_directories;
     $_PREFERENCES['anonymous_enabled_directories'] = $row->anonymous_enabled_directories;
     $_PREFERENCES['anonymous_vote_directories']    = $row->anonymous_vote_directories;
     $_PREFERENCES['anonymous_vote_media_albums']   = $row->anonymous_vote_media_albums;
	 $_PREFERENCES['ecommerce_type']                 = $row->ecommerce_type;
	 $_PREFERENCES['ecommerce_credit_card_url']      = $row->ecommerce_credit_card_url;
	 $_PREFERENCES['ecommerce_currency']             = $row->ecommerce_currency;
	 $_PREFERENCES['ecommerce_shipping_cost']        = $row->ecommerce_shipping_cost;
	 $_PREFERENCES['ecommerce_show_catalogue_price'] = $row->ecommerce_show_catalogue_price;
	 $_PREFERENCES['ecommerce_show_extra']           = $row->ecommerce_show_extra;
	 $_PREFERENCES['ecommerce_payment_type']         = $row->ecommerce_payment_type;
	 $_PREFERENCES['ecommerce_cart_expire']          = $row->ecommerce_cart_expire;
	 $_PREFERENCES['ecommerce_variable_price']       = $row->ecommerce_variable_price;
	 $_PREFERENCES['ecommerce_variable_id']          = $row->ecommerce_variable_id;
	 $_PREFERENCES['user_enabled'] = $row->user_enabled;
	 $_PREFERENCES['user_special'] = $row->user_special;
	 $_PREFERENCES['user_flag1']   = $row->user_flag1;
	 $_PREFERENCES['user_flag2']   = $row->user_flag2;
	 $_PREFERENCES['user_flag3']   = $row->user_flag3;
	 $_PREFERENCES['user_flag4']   = $row->user_flag4;
	 $_PREFERENCES['user_flag5']   = $row->user_flag5;
	 $_PREFERENCES['user_flag6']   = $row->user_flag6;
	 $_PREFERENCES['user_flag7']   = $row->user_flag7;
	 $_PREFERENCES['user_flag8']   = $row->user_flag8;
	 $_PREFERENCES['user_groupID'] = $row->user_groupID;
	 $_PREFERENCES['logging_enabled'] = $row->logging_enabled;

     return $_PREFERENCES;
    }

   public function loadPreferencesContents($languageID)
    {
     // Load contents preferences from db (1 row for language)
     $rs = wm3Sql::sqlQuery("SELECT *
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                             WHERE  languageID = '$languageID'");
     $row = mysql_fetch_object($rs);
     $_PREFERENCES_CONTENTS['browser_bar_title']               = $row->browser_bar_title;
     $_PREFERENCES_CONTENTS['title']                           = $row->title;
	 $_PREFERENCES_CONTENTS['head']                            = $row->head;
     $_PREFERENCES_CONTENTS['home']                            = $row->home;
	 $_PREFERENCES_CONTENTS['foot']                            = $row->foot;
	 $_PREFERENCES_CONTENTS['staff_name']                      = $row->staff_name;
	 $_PREFERENCES_CONTENTS['special_user_label']              = $row->special_user_label;
	 $_PREFERENCES_CONTENTS['signalation_email_subject']       = $row->signalation_email_subject;
	 $_PREFERENCES_CONTENTS['signalation_email_text']          = $row->signalation_email_text;
	 $_PREFERENCES_CONTENTS['user_registration_email_subject'] = $row->user_registration_email_subject;
	 $_PREFERENCES_CONTENTS['user_registration_email_text']    = $row->user_registration_email_text;

     return $_PREFERENCES_CONTENTS;
    }

   public static function loadTotalVisitors()
    {
     // Get total visitors from db
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT total_visitors FROM ".WM3_cCONFIG_DB_PREFIX."_counters"));
     return $row->total_visitors;
    }

   public static function loadTotalSignalations()
    {
     // Get total visitors from db
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT total_signalations FROM ".WM3_cCONFIG_DB_PREFIX."_counters"));
     return $row->total_signalations;
    }

   public static function setPreferencesBanner($positionID,$bannerID)
    {
     // Update preferences for a banner position
     $field = "banner".$positionID."ID";
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET $field = '$bannerID'");
    }

   public static function selectGeneralPreferencesFootContent($w3,$name,$value)
    {
     // Make general preferences foot content select
	 $_LABELS = array($w3->getWord(1625),$w3->getWord(59),$w3->getWord(1626),$w3->getWord(1627),$w3->getWord(60),$w3->getWord(61),$w3->getWord(1628),$w3->getWord(62));
	 $_VALUES = array(WM3_cPREFERENCES_FOOT_ALL,WM3_cPREFERENCES_FOOT_COUNTER_DATE,WM3_cPREFERENCES_FOOT_COUNTER_TIME,WM3_cPREFERENCES_FOOT_DATE_TIME,WM3_cPREFERENCES_FOOT_COUNTER,WM3_cPREFERENCES_FOOT_DATE,WM3_cPREFERENCES_FOOT_TIME,WM3_cPREFERENCES_FOOT_NONE);
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function selectEcommercePreferencesType($name,$value,$w3)
    {
     // Make ecommerce preferences type select
	 $_LABELS = array($w3->getWord(752),$w3->getWord(753));
	 $_VALUES = array(WM3_cPREFERENCES_ECOMMERCE_CATALOGUE_ONLY,WM3_cPREFERENCES_ECOMMERCE_FULL);
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function selectEcommerceFieldPreferencesType($name,$value,$w3)
    {
     // Make ecommerce preferences custom fields type select
	 $_LABELS = array($w3->getWord(1475),$w3->getWord(1476),$w3->getWord(1477));
	 $_VALUES = array(WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_INTEGER,WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_DECIMAL,WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_STRING);
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function selectEcommerceFieldPreferencesShowIn($name,$value,$w3)
    {
     // Make ecommerce preferences custom fields show in select
	 $_LABELS = array($w3->getWord(980),$w3->getWord(1478),$w3->getWord(1479));
	 $_VALUES = array(WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_CATALOGUE,WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_TRANSACTIONS,WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_BOTH);
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function makeEcommerceFieldPreferencesInputLabel($w3,$style,$_FIELD)
    {
	 // Make text fields for field labels input (one for each language)
	 $str = "";
	 $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages WHERE enabled='".WM3_cENABLED."'");
	 $p = 0;
     while($row = mysql_fetch_object($rs))
      {
	   $lang_flag = "<img src=\"".WM3_cPATH_DATA.$row->flag."\" alt=\"$row->name\" title=\"$row->name\" width=\"19\" height=\"13\" align=\"middle\">";
	   if($p == 0) $label = $w3->getWord(1226); else $label = "";
       $str .= wm3Section::makeFormItem($w3,$style,$label,"$lang_flag ".wm3Util::inputText('label'.$row->languageID,$_FIELD['label'.$row->languageID],40));
	   $p++;
      }
	 return $str;
	}

   public static function makeEcommerceFieldPreferencesSubmenu($w3,$label='')
    {
     // Create submenu for ecommerce preferences
	 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
	 array_push($_CONTENTS,wm3Util::actionButton($base_link."&section=".WM3_cSECTION_PREFERENCES."&action=".WM3_cACTION_EDIT_ECOMMERCE_PREFERENCES,"action_setup.png","","",$w3->getWord(1371),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_FIELD_PREFERENCES,"action_show.png","","",$w3->getWord(1292),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link."&action=".WM3_cACTION_ADD_ECOMMERCE_FIELD_PREFERENCES,"action_add.png","","",$w3->getWord(1472),0,16,16));
	 array_push($_CONTENTS,"<br><br>$label");
     return wm3Section::makeHeaderList($w3,$_CONTENTS,5);
	}

  }

?>
