<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Metatag
  {

   function __construct() { }

   public static function getMetatagFieldsArray()
    {
     return array('author','keywords','description','languageID');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_UPDATE_METATAG:
        {
         $error = wm3Metatag::checkMetatagError($w3);
         if(!$error)
          {
           wm3Metatag::updateMetatag($w3);
           // $msg= message udated... //TODO
           return wm3Metatag::editMetatag($w3);
          }
         else return wm3Metatag::editMetatag($w3,$error);
         break;
        }
       default:
        {
         return wm3Metatag::editMetatag($w3);
        }
      }
    }

   public static function checkMetatagError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Metatag::getMetatagFieldsArray());
     return 0;
    }

   public static function editMetatag($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_metatags");
       $row = mysql_fetch_object($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Metatag::getMetatagFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Metatag::getMetatagFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Metatag::getMetatagFieldsArray());
     switch($error)
      {
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit metatags ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_METATAG;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_metatag_form.inc");
     return $content;
    }

   public static function updateMetatag($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Metatag::getMetatagFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_metatags
                       SET author      = '".$_FIELD['author']."',
                           keywords    = '".$_FIELD['keywords']."',
                           description = '".$_FIELD['description']."'");
    }

   public static function renderMetatags()
    {
     // Render metatags
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_metatags");
     if(mysql_num_rows($rs) != 1) return ""; // No metatags found
     $row = mysql_fetch_object($rs);
     return "<meta name=\"author\" content=\"".$row->author."\">
             <meta name=\"keywords\" content=\"".$row->keywords."\">
             <meta name=\"description\" content=\"".$row->description."\">";
    }

  }

?>
